Name:		snort
Version:	2.9.3
Release:	1%{?dist}
Summary:	An open source Network Intrusion Detection System (NIDS)

Group:		Applications/Internet
License:	GPLv2
URL:		http://www.snort.org/
#Original Source URL: http://www.snort.org/downloads/1814
Source0:	%{name}-%{version}.tar.gz
Epoch:	5

BuildRequires:	autoconf automake flex bison
BuildRequires:	pcre-devel libpcap-devel libdnet-devel libprelude-devel
BuildRequires:	zlib-devel
BuildRequires:	daq >= 1.1.1
Requires(pre):	/usr/sbin/useradd
Requires(post):	/sbin/chkconfig
Requires(preun):	/sbin/chkconfig /sbin/service
Requires:	libdnet-devel logrotate

Conflicts:	rpmforge-release

Provides:	%{name}

%description
Snort is an open source network intrusion detection system, capable of
performing real-time traffic analysis and packet logging on IP networks.
It can perform protocol analysis, content searching/matching and can be
used to detect a variety of attacks and probes, such as buffer overflows,
stealth port scans, CGI attacks, SMB probes, OS fingerprinting attempts,
and much more.

%package doc
Group:  Documentation
Summary:    Document for snort.
BuildArch:  noarch

%description doc
Document for snort.

%package src
Group:  Development/Source
Summary:    Source for snort.
BuildArch:  noarch

%description src
Source for snort.

%package dynamicengine
Group:  Application/Libraries
Summary:    Dynamic Engine for snort.
Requires:   %{name} = %{epoch}:%{version}-%{release}
Provides:   %{name}-dynamicengine

%description dynamicengine
Dynamic Engine for snort.

%package dynamicpreprocessor
Group:  Application/Libraries
Summary:    Dynamic Preprocessor for snort.
Requires:   %{name} = %{epoch}:%{version}-%{release}
Provides:   %{name}-dynamicpreprocessor

%description dynamicpreprocessor
Dynamic Preprocessor for snort.

%package dynamicrules
Group:  Application/Libraries
Summary:    Dynamic Rules for snort.
Requires:   %{name} = %{epoch}:%{version}-%{release}
Provides:   %{name}-dynamicrules

%description dynamicrules
Dynamic Rules for snort.

%package dynamic_preproc
Group:  Application/Libraries
Summary:    Dynamic Preproc for snort.
Requires:   %{name} = %{epoch}:%{version}-%{release}
Provides:   %{name}-dynamic_preproc

%description dynamic_preproc
Dynamic Preproc for snort.

%prep
%setup -q


%build
%configure \
	--enable-shared=yes \
%ifarch x86_64
	--enable-64bit-gcc \
%endifarch
	--enable-dynamicplugin \
	--enable-control-socket \
	--enable-build-dynamic-examples \
	--enable-dlclose \
	--disable-static-daq \
	--enable-control-socket \
	--enable-linux-smp-stats \
	--enable-pthread \
	--enable-reload-error-restart \
	--enable-inline-init-failopen \
	--enable-sourcefire \
	--enable-shared-rep \
	--enable-large-pcap \
	--with-pic \
	--enable-mpls \
	--enable-targetbased \
	--enable-ipv6 \
	--enable-ppm \
	--enable-perfprofiling \
	--enable-zlib \
	--enable-active-response \
	--enable-normalizer \
	--enable-reload \
	--enable-react \
	--enable-flexresp3 \
	--enable-prelude

make %{?_smp_mflags}


%install
rm -rf $RPM_BUILD_ROOT

install -d -m0755 $RPM_BUILD_ROOT%{_sbindir}
install -d -m0755 $RPM_BUILD_ROOT%{_bindir}
install -d -m0755 $RPM_BUILD_ROOT%{_libdir}
install -d -m0755 $RPM_BUILD_ROOT%{_includedir}
install -d -m0755 $RPM_BUILD_ROOT%{_mandir}/man8

install -D -m0755 src/snort $RPM_BUILD_ROOT%{_sbindir}/snort
install -D -m0755 tools/control/snort_control $RPM_BUILD_ROOT%{_bindir}/snort_control
install -D -m0755 tools/u2boat/u2boat $RPM_BUILD_ROOT%{_bindir}/u2boat
install -D -m0755 tools/u2spewfoo/u2spewfoo $RPM_BUILD_ROOT%{_bindir}/u2spewfoo

install -D -m0644 snort.pc $RPM_BUILD_ROOT%{_libdir}/pkgconfig/snort.pc
install -D -m0644 src/dynamic-output/libs/snort_output.pc $RPM_BUILD_ROOT%{_libdir}/pkgconfig/snort_output.pc
install -D -m0644 src/dynamic-preprocessors/libs/snort_preproc.pc $RPM_BUILD_ROOT%{_libdir}/pkgconfig/snort_preproc.pc

install -m0755 -d $RPM_BUILD_ROOT%{_includedir}/snort/dynamic_preproc
pushd src/dynamic-preprocessors/include
for f in `find . -name \*.h -maxdepth 1`
do
	install -m0644 $f $RPM_BUILD_ROOT%{_includedir}/snort/dynamic_preproc/$f
done
popd
pushd src/dynamic-preprocessors/libs
for f in `find . -name \*.h -maxdepth 1`
do
	install -m0644 $f $RPM_BUILD_ROOT%{_includedir}/snort/dynamic_preproc/$f
done
popd

install -d -m0755 $RPM_BUILD_ROOT%{_libdir}/snort/snort_dynamicengine
install -m0755 src/dynamic-plugins/sf_engine/.libs/libsf_engine.so.0.0.0 $RPM_BUILD_ROOT%{_libdir}/snort/snort_dynamicengine/libsf_engine.so.0.0.0
pushd $RPM_BUILD_ROOT%{_libdir}/snort/snort_dynamicengine
ln -sf libsf_engine.so.0.0.0 libsf_engine.so.0
ln -sf libsf_engine.so.0.0.0 libsf_engine.so
popd

install -d -m0755 $RPM_BUILD_ROOT%{_libdir}/snort/snort_dynamicpreprocessor
install -m0755 src/dynamic-examples/dynamic-preprocessor/.libs/lib_sfdynamic_preprocessor_example.so.0.0.0 $RPM_BUILD_ROOT%{_libdir}/snort/snort_dynamicpreprocessor/lib_sfdynamic_preprocessor_example.so.0.0.0
pushd $RPM_BUILD_ROOT%{_libdir}/snort/snort_dynamicpreprocessor
ln -sf lib_sfdynamic_preprocessor_example.so.0.0.0 lib_sfdynamic_preprocessor_example.so.0
ln -sf lib_sfdynamic_preprocessor_example.so.0.0.0 lib_sfdynamic_preprocessor_example.so
popd

install -D -m0644 src/dynamic-plugins/sf_engine/libsf_engine.la $RPM_BUILD_ROOT%{_libdir}/snort/snort_dynamicengine/libsf_engine.la
pushd src/dynamic-examples/dynamic-preprocessor/.libs
for f in lib_sfdynamic_preprocessor_example.a lib_sfdynamic_preprocessor_example.la
do
	install -m0644 $f $RPM_BUILD_ROOT%{_libdir}/snort/snort_dynamicpreprocessor/$f
done
popd

%{__cp} -rp src/dynamic-preprocessors/build/usr/lib/snort_dynamicpreprocessor/* $RPM_BUILD_ROOT%{_libdir}/snort/snort_dynamicpreprocessor/

install -D -m0644 src/dynamic-examples/dynamic-rule/lib_sfdynamic_example_rule.la $RPM_BUILD_ROOT%{_libdir}/snort/snort_dynamicrules/lib_sfdynamic_example_rule.la

pushd src/dynamic-examples/dynamic-rule/.libs
install -m0644 lib_sfdynamic_example_rule.a $RPM_BUILD_ROOT%{_libdir}/snort/snort_dynamicrules/lib_sfdynamic_example_rule.a
install -m0755 lib_sfdynamic_example_rule.so.0.0.0 $RPM_BUILD_ROOT%{_libdir}/snort/snort_dynamicrules/lib_sfdynamic_example_rule.so.0.0.0
popd

pushd $RPM_BUILD_ROOT%{_libdir}/snort/snort_dynamicrules
ln -sf lib_sfdynamic_example_rule.so.0.0.0 lib_sfdynamic_example_rule.so.0
ln -sf lib_sfdynamic_example_rule.so.0.0.0 lib_sfdynamic_example_rule.so
popd

install -D -m0644 snort.pc $RPM_BUILD_ROOT%{_libdir}/pkgconfig/snort.pc
install -D -m0644 src/dynamic-preprocessors/libs/snort_preproc.pc $RPM_BUILD_ROOT%{_libdir}/pkgconfig/snort_preproc.pc

install -D -m0644 src/dynamic-preprocessors/build/%{_libdir}/snort/dynamic_preproc/libsf_dynamic_preproc.la $RPM_BUILD_ROOT%{_libdir}/snort/dynamic_preproc/libsf_dynamic_preproc.la
install -D -m0644 src/dynamic-preprocessors/build/%{_libdir}/snort/dynamic_preproc/libsf_dynamic_preproc.a $RPM_BUILD_ROOT%{_libdir}/snort/dynamic_preproc/libsf_dynamic_preproc.a

install -D -m0644 snort.8 $RPM_BUILD_ROOT%{_mandir}/man8/snort.8

pushd src/dynamic-preprocessors/include
for f in `find . -name \*.\[ch\]`
do
    install -D -m0644 $f $RPM_BUILD_ROOT%{_docdir}/snort_dynamicsrc/$f
done
popd

install -d -m0755 $RPM_BUILD_ROOT%{_sysconfdir}/%{name}
install -d -m0755 $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/rules
install -d -m0755 $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/preproc_rules
install -d -m0755 $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
install -d -m0755 $RPM_BUILD_ROOT%{_sysconfdir}/rc.d
install -d -m0755 $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d
install -d -m0755 $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d
install -d -m0755 $RPM_BUILD_ROOT%{_localstatedir}/log
install -d -m0755 $RPM_BUILD_ROOT%{_localstatedir}/log/snort

rm -rf etc/Makefile*
rm -rf preproc_rules/Makefile*

pushd etc
sed -i -e 's,/usr/local/lib,%{_libdir}/snort,g' \
	-e 's,RULE_PATH ../rules,RULE_PATH rules,' \
	-e 's,var SO_RULE_PATH ../so_rules,#var SO_RULE_PATH so_rules,' \
	-e 's,PREPROC_RULE_PATH ../preproc_rules,PREPROC_RULE_PATH preproc_rules,' \
	-e 's,WHITE_LIST_PATH ../rules,WHITE_LIST_PATH rules,' \
	-e 's,BLACK_LIST_PATH ../rules,BLACK_LIST_PATH rules,' \
	snort.conf

for f in `find . -type f`
do
	install -m0644 $f $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/$f
done
popd

pushd preproc_rules
for f in `find . -type f`
do
	install -m0644 $f $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/preproc_rules/$f
done
popd

install -D -m0755 rpm/snortd $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/snortd
install -D -m0644 rpm/snort.sysconfig $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/snort
install -D -m0644 rpm/snort.logrotate $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/snort

%pre
getent group snort > /dev/null || groupadd -r snort
getent passwd snort > /dev/null || \
    useradd -r -g snort -d %{_localstatedir}/log/%{name} -s /sbin/nologin \
    -c 'Snort IDS System' snort
:

%post
/sbin/service snortd condrestart 1>/dev/null 2>/dev/null

if [ $1 = 1 ] ; then
	chown -R snort.snort %{_localstatedir}/log/%{name}
	/sbin/chkconfig --add snortd
fi

%preun
if [ $1 -eq 0 ] ; then
	/sbin/service snortd stop > /dev/null 2>&1 || :
	/sbin/chkconfig --del snortd
fi

%postun
if [ $1 -ge 1 ]; then
	/sbin/service snortd condrestart > /dev/null 2>&1 || :
fi
# Only do this if we are actually removing snort
if [ $1 -eq 0 ] ; then
	if [ -L %{_sbindir}/snort ]; then
		rm -f %{_sbindir}/snort
	fi
	/usr/sbin/userdel snort 2>/dev/null
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%doc COPYING ChangeLog LICENSE RELEASE.NOTES doc/* rpm/README* rpm/RPM-TODO
%{_sbindir}/snort
%{_bindir}/snort_control
%{_bindir}/u2boat
%{_bindir}/u2spewfoo
%{_libdir}/pkgconfig/*.pc
%{_includedir}/snort/dynamic_preproc/*.h
%{_mandir}/man8/*.8*
%{_sysconfdir}/logrotate.d/snort
%{_sysconfdir}/rc.d/init.d/snortd
%{_sysconfdir}/snort/attribute_table.dtd
%{_sysconfdir}/snort/classification.config
%{_sysconfdir}/snort/gen-msg.map
%{_sysconfdir}/snort/reference.config
%config(noreplace) %{_sysconfdir}/snort/snort.conf
%config(noreplace) %{_sysconfdir}/snort/threshold.conf
%{_sysconfdir}/snort/unicode.map
%{_sysconfdir}/sysconfig/snort
%{_sysconfdir}/snort/preproc_rules/decoder.rules
%{_sysconfdir}/snort/preproc_rules/preprocessor.rules
%{_sysconfdir}/snort/preproc_rules/sensitive-data.rules
%attr(0700,snort,snort) %{_localstatedir}/log/snort

%files dynamicengine
%defattr(-,root,root,-)
%{_libdir}/snort/snort_dynamicengine/*

%files dynamicpreprocessor
%{_libdir}/snort/snort_dynamicpreprocessor/*.a
%{_libdir}/snort/snort_dynamicpreprocessor/*.la
%{_libdir}/snort/snort_dynamicpreprocessor/*.so*

%files dynamicrules
%{_libdir}/snort/snort_dynamicrules/*.a
%{_libdir}/snort/snort_dynamicrules/*.la
%{_libdir}/snort/snort_dynamicrules/*.so*

%files dynamic_preproc
%{_libdir}/snort/dynamic_preproc/libsf_dynamic_preproc.a
%{_libdir}/snort/dynamic_preproc/libsf_dynamic_preproc.la

%files doc
%doc doc/*

%files src
%defattr(-,root,root,-)
%{_docdir}/snort_dynamicsrc/*

%changelog
* Fri Aug  3 2012 momo-i <webmaster@momo-i.org> 2.9.3-1
- Initial rpm release.
